/*
 * CompArea.java
 *
 * Created on Utorok, 2008, marec 18, 20:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package elcuit;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.image.BufferStrategy;
import java.util.ListIterator;
/**
 *
 * @author pc
 */
public class CompArea extends java.awt.Canvas{

    /** Creates a new instance of CompArea */
    public CompArea() {
    }

        public void update(Graphics g) {
	Graphics offgc;
	Image offscreen = null;
	Rectangle box = g.getClipRect();

	// create the offscreen buffer and associated Graphics
	offscreen = createImage(box.width, box.height);
	offgc = offscreen.getGraphics();
	// clear the exposed area
	offgc.setColor(getBackground());
	offgc.fillRect(0, 0, box.width, box.height);
	offgc.setColor(getForeground());
	// do normal redraw
	offgc.translate(-box.x, -box.y);
	paint(offgc);
	// transfer offscreen to window
	g.drawImage(offscreen, box.x, box.y, this);
    }

    public void paint (Graphics g) {
        MainWindow okno = MainWindow.okno;
        if (okno == null) return;
        Component_List zoznam = okno.zoznam();
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam.zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c != null) c.Draw(g);
        }
        for (ListIterator<Wire> it = zoznam.vodice().listIterator(); it.hasNext();) {
            Wire w = it.next();
            if (w != null) {
                g.setColor((w.I != 0) ? Color.blue : Color.black);
                Point p1 = w.comp1.connector(w.con1);
                Point p2 = w.comp2.connector(w.con2);
                g.drawLine(p1.x, p1.y, p2.x, p2.y);
            }
        }
        // tahany vodic
        Point v = okno.vodicFrom();
        if (v != null)
            g.drawLine(v.x, v.y, okno.vodicX(), okno.vodicY());
        if(okno.Selected() != null){
            Point p = okno.Selected().connector(okno.Selected_Connector());
            g.setColor(Color.red);
            g.fillOval(p.x-5, p.y-5, 11, 11);
        }
        if (prud != 0.0) {
            g.setColor(Color.black);
            int h = (int) getSize().getHeight();
            g.drawString("Prd: " + prud + " A", h-20, 10);
        }
    }
    
    public void zmenPrud (double I) {
        if (prud == I) return;
        prud = I;
        repaint();
    }
    private double prud = 0.0;

    public boolean isDoubleBuffered () {
        return true;
    }
}