/*
 * Graph.java
 *
 * Created on Nedea, 2008, aprl 6, 13:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package elcuit;

import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Timer;
import java.util.TimerTask;
import java.util.TreeMap;
import javax.swing.JOptionPane;

/**
 *
 * @author pc
 */
public class Graph {
    
    private class Vrchol{
        AComponent c;
        int i; //Ktory vrchol daneho komponentu
        LinkedList<Hrana> hrany = new LinkedList<Hrana>();
        int num;
    };
    
    private class Hrana{
        Vrchol v1, v2;
        Vrchol start;
        Cesta c = null;
        Wire wire = null;
    };
    
    private class Cyklus{
        LinkedList<Cesta> cesty = new LinkedList<Cesta>();
        Vrchol vychodzi = null;
    };
    
    private class Cesta{
        Vrchol v1, v2;
        LinkedList<Hrana> hrany = new LinkedList<Hrana>();
        boolean ozn = false;
        int cislo;
        LinkedList<Cyklus> cykly = new LinkedList<Cyklus>();
    };
    
    private LinkedList<Vrchol> vrcholy = new LinkedList<Vrchol>();
    private LinkedList<Hrana> hrany = new LinkedList<Hrana>();
    private LinkedList<Cesta> cesty = new LinkedList<Cesta>();
    private LinkedList<Cyklus> cykly = new LinkedList<Cyklus>();
    private int ciest = 0, vrcholov = 0, riadkovMatice = 0;
    
    private TreeMap<Integer, TreeMap<Integer, Double> > matica = new TreeMap<Integer, TreeMap<Integer, Double> >();
    
    private double matGet (int col, int row) {
        Integer x = new Integer (col);
        Integer y = new Integer (row);
        if (!matica.containsKey(x)) return 0;
        Double res = matica.get(x).get(y);
        return (res == null) ? 0.0 : res.doubleValue();
    }
    
    private void matSet (int col, int row, double val) {
        Integer x = new Integer (col);
        Integer y = new Integer (row);
        Double v = new Double (val);
        if (!matica.containsKey(x))
            matica.put(x, new TreeMap<Integer, Double>());
        matica.get(x).put (y, v);
    }
    
    private void clearMat () {
        matica.clear();
        riadkovMatice=0;
    }
    
    public Vrchol getVrchol(AComponent c, int i){
        Vrchol v = null;
        for (ListIterator<Vrchol> it2 = vrcholy.listIterator(); it2.hasNext();) {
            v = it2.next();
            if (v != null) {
                if((v.c == c) && (v.i == i)){
                    return v;
                }
            } 
        } 
        return null;
    }
    
    public void generate(){
        vrcholy.clear();
        hrany.clear();
        cesty.clear();
        cykly.clear();
        ciest=0;
        vrcholov=0;
        MainWindow okno = MainWindow.okno;
        Component_List zoznam = okno.zoznam();
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam.zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c != null) {
                int o = c.connector_count();
                for (int i = 1; i<=o; i++){
                    Vrchol v = new Vrchol();
                    v.num = ++vrcholov;
                    v.c = c;
                    v.i = i;
                    vrcholy.add(v);
                }
                LinkedList<Integer> v_hrany = c.hrany();
                if (v_hrany!=null){
                    ListIterator<Integer> iti = v_hrany.listIterator();
                    while (iti.hasNext()) {
                        int conn1 = iti.next().intValue();
                        int conn2 = iti.next().intValue();
                        Hrana h = new Hrana();
                        h.v1 = getVrchol(c, conn1);
                        h.v2 = getVrchol(c, conn2);
                        h.v1.hrany.add(h);
                        h.v2.hrany.add(h);
                        hrany.add(h);
                    }
                }
            }
        }
        for (ListIterator<Wire> it = zoznam.vodice().listIterator(); it.hasNext();) {
            Wire w = it.next();
            if (w != null) {
                Hrana h = new Hrana();
                h.v1 = getVrchol(w.comp1, w.con1);
                h.v2 = getVrchol(w.comp2, w.con2);
                h.wire = w;
                h.v1.hrany.add(h);
                h.v2.hrany.add(h);
                hrany.add(h);
            }
        }     
    }
    
    public void prechod(){
        Vrchol v = null;
        for (ListIterator<Vrchol> it2 = vrcholy.listIterator(); it2.hasNext();) {
            v = it2.next();
            if (v == null) continue;
            int p = v.hrany.size();
            if (p == 2) continue;
            prejdi_vrchol (v);
        } 
        for (ListIterator<Vrchol> it2 = vrcholy.listIterator(); it2.hasNext();) {
            v = it2.next();
            if (v == null) continue;
            int p = v.hrany.size();
            if (p == 2) {
                 prejdi_vrchol (v);
            }
        } 
        generuj_cykly();
    }
    
    private void prejdi_vrchol(Vrchol v){
        if (v.hrany.size() == 0){
            Cesta c = new Cesta();
            c.cislo = ++ciest;
            c.v1 = v;
            c.v2 = v;
            cesty.add(c);
            return;
        }
        for (ListIterator<Hrana> it3 = v.hrany.listIterator(); it3.hasNext();) {
            Hrana h = it3.next();
            if(h.c != null) continue;
            Cesta c = new Cesta();
            c.cislo = ++ciest;
            c.v1 = v;
            Vrchol v2 = v;
            do {
                // mame hranu h a jeden jej vrchol - cesta pokracuje tym druhym vrcholom hrany
                // takze si do v2 nastavime druhy vrchol cesty
                if(h.v1 == v2) v2 = h.v2;
                else v2 = h.v1;
                // "ofarbime" nasu hranu
                h.c = c;
                c.hrany.add(h); 
                // ak koncovy vrchol nie je konecny (pocet hran != 2), musime najst novu hranu
                // tu hranu budeme pouzivat v dalsej iteracii
                if (v2.hrany.size() == 2) {
                    if(v2.hrany.get(0) == h) h = v2.hrany.get(1);
                    else h = v2.hrany.get(0);
                }
            } while ((v2.hrany.size() == 2) && (v2 != v));
            c.v2 = v2;
            cesty.add(c);
        }
    }

    private Vrchol vychodziVrchol = null;
    private Cyklus generovanyCyklus = null;
    
    private void generuj_cykly() {
        // pre kazdu cestu:
        Cesta c = null;
        for (ListIterator<Cesta> c1 = cesty.listIterator(); c1.hasNext();) {
            c = c1.next();
            if (c == null) continue;   
        // ak je cesta uz sucastou niektoreho cyklu, OK, pokracujeme dalsou
            if (!c.cykly.isEmpty()) continue;     
        // odznacime vsetky cesty
            for (ListIterator<Cesta> c2 = cesty.listIterator(); c2.hasNext();) {
                Cesta cs = c2.next();
                if (cs == null) continue;
                cs.ozn = false;
            }  
            
        // oznacime jeden vrchol ako vychodzi a zapamatame si ho
            vychodziVrchol = c.v1;
        // oznacime tuto cestu
            c.ozn = true;
            generovanyCyklus = null;
        // spustime backtrack pocnuc druhym vrcholom
            generuj_cykly_bt (c.v2, c);
        }
    }
    
    private void generuj_cykly_bt(Vrchol v, Cesta c) {
        // jeden krok backtracku, vychadza z tohoto vrcholu
        // ak sme prave prisli do vrcholu z ktoreho sme NA ZACIATKU vysli, ok, zapiseme cyklus, zapamatame si ze sme nieco nasli a koniec
        if (vychodziVrchol == v){
            Cyklus cyk = new Cyklus();
            cykly.add(cyk);
            cyk.cesty.add(c);
            generovanyCyklus = cyk;
            cyk.vychodzi = vychodziVrchol;
            c.cykly.add (cyk);
            return;
        }
        // zistime, ci z tohto vrcholu vychadza cesta ktora je oznacena a je ina od tej ktorou sme prisli
        // ak taka existuje, koncime a vraciame sa vyssie
        Cesta cc = null;
        for (ListIterator<Cesta> c1 = cesty.listIterator(); c1.hasNext();) {
            cc = c1.next();
            if (cc.ozn && (cc != c) && ((cc.v1==v) || (cc.v2==v))) return;
        }
        // pre kazdu cestu:
        for (ListIterator<Cesta> c1 = cesty.listIterator(); c1.hasNext();) {
            cc = c1.next();
        // ak nevychadza z nasho vrcholu, tak pokracujeme
            if((cc.v1 != v)&&(cc.v2 != v)) continue;
        // ak je to cesta ktorou sme sem prisli tak pokracujeme
            if (cc == c) continue;
        // inak sa vnarame do rekurzie
        // takze oznacime cestu
            cc.ozn = true;
        // zavolame rekurzivne seba s vrcholom na druhom konci
            Vrchol vv = (cc.v1 == v) ? cc.v2 : cc.v1; 
            generuj_cykly_bt(vv, cc);
        // vratili sme sa z rekurzie - ak sme nasli nieco, tak koniec
            if (generovanyCyklus != null) {
                generovanyCyklus.cesty.add (c);
                c.cykly.add (generovanyCyklus);
                return;
            }
        // odznacime tuto cestu - nevedie k rieseniu
            c.ozn = false;
        // a pokracujeme v cykle dalej
        }
    }
    
    
    private void matice(){
        // vytvorime maticu, pocet stlpcov = pocet ciest + 1, pocet riadkov neznamy
        

        // +++ kirchhoff 1 +++
        
        // pre kazdy vrchol
        Vrchol v = null;
        for (ListIterator<Vrchol> it = vrcholy.listIterator(); it.hasNext();) {
            v = it.next();
            if (v.hrany.size() == 2) continue; 
            // najdeme zoznam ciest vychadzajucich z vrcholu
            // a vygenerujeme riadok matice, pricom musime urcit znamienko - smer prudu urcime ako v1->v2
            riadkovMatice++;
            Cesta c = null;
            for (ListIterator<Cesta> c1 = cesty.listIterator(); c1.hasNext();) {
                c = c1.next();
                if(!(c.v1 == v || c.v2 == v)) continue;
                int smer = (c.v1.num < c.v2.num) ? -1 : 1;
                if (c.v1 == v) smer = -smer;
                matSet (c.cislo, riadkovMatice, smer);
            }    
        }
 
        // +++ kirchhoff 2 +++
        
        Cyklus o = null;
        for (ListIterator<Cyklus> ok = cykly.listIterator(); ok.hasNext();) {
            o = ok.next();
            riadkovMatice++;
            double U = 0;
            Cesta c = null;
            Vrchol poc = o.vychodzi;
            for (ListIterator<Cesta> c1 = o.cesty.listIterator(); c1.hasNext();) {
                c = c1.next();
                int smer = (c.v1.num < c.v2.num) ? -1 : 1;
                int mojSmer = (poc == c.v1) ? 1 : -1;
                if (smer != mojSmer) smer = -smer;
                Hrana h = null;
                double R = 0;
                Vrchol pp = poc;
                for (ListIterator<Hrana> hi = c.hrany.listIterator(); hi.hasNext();) {
                    h = hi.next();
                    // zistime U a R na tejto vetve
                    // ak su konce tejto hrany v inom komponente, je to nula
                    if (h.v1.c != h.v2.c) continue;
                    // ak su konce v rovnakom komponente, spytame sa ho na U a R
                    // parametre musia ist v smere popisu obvodu
                    int od = (pp == h.v1) ? h.v1.i : h.v2.i;
                    int ciel = (pp == h.v1) ? h.v2.i : h.v1.i;
                    h.start = (pp == h.v1) ? h.v1 : h.v2;
                    U += smer * h.v1.c.napatie(od, ciel);
                    R += smer * h.v1.c.odpor(od, ciel);
                    pp = (pp == h.v1) ? h.v2 : h.v1;
                }
                matSet (c.cislo, riadkovMatice, R);
                poc = (poc == c.v1) ? c.v2 : c.v1;
            }
            matSet (ciest + 1, riadkovMatice, U);
        }    
    }
    
    void ries_maticu () {
        int i = 1;
        int j = 1;
        int m = riadkovMatice;
        int n = ciest+1;
        for (int ii = 1; ii <= m; ii++) {
            String ss = new String();
            for (int jj = 1; jj <= n; jj++) {
                if (jj<n)ss += matGet(jj, ii)+"I"+jj;
                if (jj<n-1) ss += " + ";
                if (jj==n-1) ss += " = ";
                if (jj == n) ss += matGet(jj, ii);
            }
            System.out.println (ss);
        }
        while ((i <= m) && (j <= n)) {
          // Find pivot in column j, starting in row i:
          int maxi = i;
          for (int k = i+1; k <= m; k++) {
            if (Math.abs(matGet (j, k)) > Math.abs(matGet (j, maxi)))
              maxi = k;
          }
          if (matGet (j, maxi) != 0) {
            // swap rows i and maxi, but do not change the value of i
            for (int col = 1; col <= n; col++) {
              double p = matGet (col, i);
              matSet (col, i, matGet (col, maxi));
              matSet (col, maxi, p);
            }
            // Now A[i,j] will contain the old value of A[maxi,j].
            // divide each entry in row i by A[i,j]
            double div = matGet (j, i);
            for (int col = 1; col <= n; col++)
                matSet (col, i, matGet (col, i) / div);
            
            // Now A[i,j] will have the value 1.
            for (int u = i+1; u <= m; u++) {
              // subtract A[u,j] * row i from row u
              double uj = matGet (j, u);
              for (int col = 1; col <= n; col++)
                matSet (col, u, matGet (col, u) - matGet (col, i) * uj);
              // Now A[u,j] will be 0, since A[u,j] - A[i,j] * A[u,j] = A[u,j] - 1 * A[u,j] = 0.
            }
            i++;
          }
          j++;
        }

        // back-substitution
        for (i = n-1; i >= 1; i--) {
            double v = matGet (i, i);  // 1 alebo 0
            double val = matGet (ciest+1, i);
            if (v == 0) {
                System.out.println ("Neriesitelny obvod.");
                JOptionPane.showMessageDialog(MainWindow.okno, "Obvod je nerieiten - pravdepodobne skrat.", "Chybn obvod", JOptionPane.ERROR_MESSAGE);
                stop();
                return;
            }
            for (j = 1; j < i; j++) {
                double vv = matGet (i, j);
                if (vv == 0) continue;
                matSet (i, j, 0);
                matSet (ciest+1, j, matGet (ciest+1, j) - val*vv);
            }
        }
        System.out.println ("VYSLEDKY");
        for (int ii = 1; ii <= m; ii++) {
            String ss = new String();
            for (int jj = 1; jj <= n; jj++) {
                if (jj<n)ss += matGet(jj, ii)+"I"+jj;
                if (jj<n-1) ss += " + ";
                if (jj==n-1) ss += " = ";
                if (jj == n) ss += matGet(jj, ii);
            }
            System.out.println (ss);
        }

    }
    
    void urci_prudy () {
        Cesta c = null;
        for (ListIterator<Cesta> c1 = cesty.listIterator(); c1.hasNext();) {
            c = c1.next();
            double I = matGet (ciest + 1, c.cislo);

            Hrana h = null;
            for (ListIterator<Hrana> hi = c.hrany.listIterator(); hi.hasNext();) {
                h = hi.next();
                if (h.wire != null) h.wire.I = I;
                else {
                    int od = (h.start == h.v1) ? h.v1.i : h.v2.i;
                    int ciel = (h.start == h.v1) ? h.v2.i : h.v1.i;                    
                    h.v1.c.nastav_prud (od, ciel, I);
                }
                
            }
        }
        
    }
    
    void urci_potencialy () {
        // TODO
    }
    
    void vynuluj_prudy () {
        Component_List zoznam = MainWindow.okno.zoznam();
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam.zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c == null) continue;
            c.reset();
        }
        for (ListIterator<Wire> it = zoznam.vodice().listIterator(); it.hasNext();) {
            Wire w = it.next();
            if (w != null) w.I = 0.0;
        }
    }

    void reset_comp () {
        Component_List zoznam = MainWindow.okno.zoznam();
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam.zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c == null) continue;
            c.stopped();
        }
    }

    void simulacia () {
        clearMat();
        generate();
        prechod();
        matice();
        ries_maticu();
        vynuluj_prudy();
        urci_prudy();
        urci_potencialy();
    }
    
    class Spustac extends TimerTask {
        public Graph g = null;
        public void run () {
            if (g == null) return;
            g.simulacia();
            if (g.running())
                g.start();
            else {
                g.vynuluj_prudy();
                g.reset_comp();
            }
            MainWindow.okno.redraw();
        }
    }
    void start () {
        _stop = false;
        timer.purge();
        Spustac s = new Spustac();
        s.g = this;
        timer.schedule(s, 0);
    }
    void stop () {
        _stop = true;
    }
    boolean running () {
        return !_stop;
    }
    
    private Timer timer = new Timer();
    private boolean _stop = true;
    
    /** Creates a new instance of Graph */
    public Graph() {
        
    }

        public boolean is_stop() {
            return _stop;
        }
}   

